extends ../layouts/navbar
include ../components/successerrorbox

block content
    h1 View Quiz Attempts for #{quizData.name}
    p Select a quiz taker to view details about attempts made

    +successerror(sucmsg, errmsg)

    table#studentQuizTable.table.w-100

    include ../meta/datatables

    script.
        $(document).ready(() => {
            let table;
            table = $('#studentQuizTable').DataTable({
                ajax: '/reports/students/#{quizid}/data',
                dom: 'Brftilp',
                buttons: [
                    {
                        text: 'Go Back',
                        action: () => window.location.href = `#{redirectLink}`
                    },
                    {
                        text: 'Show Instructors',
                        action: (e, dt, button) => {
                            if (table.column(1).search() === 'false') {
                                button.text('Hide Instructors');
                                table.column(1).search('').draw();
                            } else {
                                button.text('Show Instructors');
                                table.column(1).search('false').draw();
                            }
                        }
                    },
                    {
                        extend: 'excelHtml5',
                        filename: 'quizreport-#{quizid}-#{courseData.code}',
                        autoFilter: true,
                        createEmptyCells: true,
                        exportOptions: {columns: ':visible'},
                        title: ''
                    },
                    {
                        extend: 'csvHtml5',
                        exportOptions: {columns: ':visible'},
                        filename: 'quizreport-#{quizid}-#{courseData.code}'
                    },
                    {
                        extend: 'pdfHtml5',
                        filename: 'quizreport-#{quizid}-#{courseData.code}',
                        orientation: 'landscape',
                        customize: function (doc) {
                            doc.content[1].table.widths =
                                Array(doc.content[1].table.body[0].length + 1).join('*').split('');
                        },
                        exportOptions: {columns: ':visible'},
                        pageSize: 'A4',
                        title: `Quiz Report - #{quizData.name} - [#{courseData.code}] #{courseData.name}`
                    }
                ],
                select: 'single',
                responsive: true,
                deferRender: true,
                columns: [
                    {title: "Name", data: "name"},
                    {title: "instructor", data: "instructor", visible: false},
                    {title: "Email", data: "email"},
                    {title: "Department", data: "deptShort"},
                    {title: "Username", data: "username"},
                    {title: "Highest Quiz Score", data: "highScore"},
                    {title: "Attempts Made", data: "attempts"}
                ]
            });

            $("body").tooltip({ selector: '[data-toggle=tooltip]', trigger: 'hover' });
            table.on('select', (e,dt,type,indexes) => {
                let rowData = table.rows( indexes ).data().toArray()[0];
                window.location.href = `/reports/attempts/#{quizid}/${rowData.userid}`;
            });
            table.on('init', () => table.column(1).search('false').draw()); // Show only students
            table.on('draw', () => MathJax.typesetPromise())
        });
